/**
 * TP1.java
 * 
 * Time-stamp: <2012-12-20 23:08:08 ftaiani>
 * @author Francois Taiani   <f.taiani@lancaster.ac.uk>
 * $Id$
 * 
 */

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

class Inserter extends Thread {
  public void run() {
    for(int i=0;i<10000;i++) {
      // insert the thread's ID at a random position in the list
			TP1.globalList.add(TP1.rand.nextInt(TP1.globalList.size()+1),this.getId());
		}
	}
}

class Remover extends Thread {
  public void run() {
    for(int i=0;i<10000;i++) {
      // remove an ID at a random position in the list
			TP1.globalList.remove(TP1.rand.nextInt(TP1.globalList.size()));
		}
  }
}

class Observer extends Thread {

  // Here 'volatile' means that continueToWork will be accessed /
  // modified by several threads and should therefore behave as an
  // atomic concurrent object. (Not guaranteed without volatile, in
  // particular because of caching by threads.)

  public volatile boolean continueToWork = true ;

  public void run() {
    try {
      while(continueToWork) {
        System.err.println("Size of list: " + TP1.globalList.size());
        Thread.sleep(200);
      }
    } 
    catch(InterruptedException e) {
      e.printStackTrace(); // thread terminates if interrupted
    }
  }
}

/**
 * @author Francois Taiani   <f.taiani@lancaster.ac.uk>
 */
public class TP1 {

  static public List<Long> globalList = new ArrayList<Long>();
  static public Random rand = new Random();
  
  public static void main(String[] args) throws InterruptedException {
    Observer observe = new Observer();
    observe.start();

    List<Thread> allThreads = new ArrayList<Thread>();
    
    // Creating the 10 Inserters, 10 Removers
    for(int i=0;i<10;i++) {
      Thread insert = new Inserter();
      Thread remove = new Remover();
      remove.start();
      insert.start();
      // keeping a reference on the threads we have created
      allThreads.add(insert);
      allThreads.add(remove);
    } // EndFor

    // waiting for all threads to terminate
    for(Thread t : allThreads) { t.join(); }

    Thread.sleep(800); // so we can see that the list has stabilised
    observe.continueToWork = false ; // telling observer thread to stop

  } // EndMain
  
} // EndClass TP1
