/**
 * TP2PlainLock.java
 * 
 * Time-stamp: <2012-12-21 15:05:54 ftaiani>
 * @author Francois Taiani   <f.taiani@lancaster.ac.uk>
 * $Id$
 * 
 */

import java.util.concurrent.locks.ReentrantLock;
import java.util.concurrent.locks.Lock;

class Incrementer extends Thread {
  public void run() {
    for(int i=0;i<10000000;i++) {
      TP2PlainLock.lock.lock();
      TP2PlainLock.counter++;
      TP2PlainLock.lock.unlock();
    }
	}
} // EndClass Inserter

class Reader extends Thread {
  public void run() {
    TP2PlainLock.lock.lock();
    for(int i=0;i<100000000;i++) {
      long x = TP2PlainLock.counter ;
      if (i%2000000==0) System.err.println(this.getId()+" : "+x);
    }
    TP2PlainLock.lock.unlock();
  }
} // EndClass Reader


/**
 * @author Francois Taiani   <f.taiani@lancaster.ac.uk>
 */
public class TP2PlainLock {

  static long counter = 0;
  static Lock lock = new ReentrantLock();

  public static void main(String[] args) throws InterruptedException {

    Thread[] readers      = new Thread[15];

    Thread incrementer = new Incrementer(); // only one writing thread
    incrementer.start();

    for(int i=0;i<15;i++) {
      readers[i] = new Reader();
      readers[i].start();
    }

    // waiting for incrementers to finish
    incrementer.join();

    // waiting for readers to finish
    for(int i=0;i<15;i++) {
      readers[i].join();
    }
    
    System.err.println("End value: "+ counter);

  } // EndMain

} // EndClass TP2PlainLock
