import java.util.concurrent.locks.ReentrantLock;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.Semaphore;

class BasicLock {
  private Semaphore semaphore = new Semaphore(1);
  public void lock() {
    try {
      semaphore.acquire();
    } 
    catch(Exception e) {
      e.printStackTrace();
      System.exit(1);
    }
  }
  public void unlock() {
    semaphore.release();
  }
}

public class MyAlpacaRWLock {

	private int nbReaders = 0;
	
	private BasicLock lockFile, lockPriority, lockNbReader;
	
	public MyAlpacaRWLock() {
		this.lockFile     = new BasicLock();
		this.lockNbReader = new BasicLock();
	}
	
	public void lockRead() { 
		this.lockNbReader.lock();
		if(this.nbReaders == 0) 
			this.lockFile.lock();
		
		this.nbReaders++;		
		this.lockNbReader.unlock();
	}
	
	public void unlockRead() {
		this.lockNbReader.lock();
		this.nbReaders--;
		if(this.nbReaders == 0) 
			this.lockFile.unlock();
		
		this.lockNbReader.unlock();
	
	}
	
	public void lockWrite() {
		this.lockFile.lock();	
	}
	
	public void unlockWrite() {
		this.lockFile.unlock();	
	}
}
